'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OldValue = require('../old-value');
var Value = require('../value');

var Stretch = function (_Value) {
    _inherits(Stretch, _Value);

    function Stretch() {
        _classCallCheck(this, Stretch);

        return _possibleConstructorReturn(this, _Value.apply(this, arguments));
    }

    /**
     * Different prefix for WebKit and Firefox
     */
    Stretch.prototype.replace = function replace(string, prefix) {
        if (prefix === '-moz-') {
            return string.replace(this.regexp(), '$1-moz-available$3');
        } else if (prefix === '-webkit-') {
            return string.replace(this.regexp(), '$1-webkit-fill-available$3');
        } else {
            return _Value.prototype.replace.call(this, string, prefix);
        }
    };

    /**
     * Different name for WebKit and Firefox
     */


    Stretch.prototype.old = function old(prefix) {
        if (prefix === '-moz-') {
            return new OldValue(this.name, '-moz-available');
        } else if (prefix === '-webkit-') {
            return new OldValue(this.name, '-webkit-fill-available');
        } else {
            return _Value.prototype.old.call(this, prefix);
        }
    };

    return Stretch;
}(Value);

Object.defineProperty(Stretch, 'names', {
    enumerable: true,
    writable: true,
    value: ['stretch', 'fill', 'fill-available']
});


module.exports = Stretch;